﻿using System;
using System.Threading;

namespace PacManGame
{
    class PlayerController
    {
        public event EventHandler OnWPressed;
        public event EventHandler OnSPressed;
        public event EventHandler OnAPressed;
        public event EventHandler OnDPressed;

        public void StartListening()
        {
            while (true)
            {
                ConsoleKeyInfo key = Console.ReadKey(true);

                switch (key.Key)
                {
                    case ConsoleKey.W:
                        OnWPressed?.Invoke(this, EventArgs.Empty);
                        break;
                    case ConsoleKey.S:
                        OnSPressed?.Invoke(this, EventArgs.Empty);
                        break;
                    case ConsoleKey.A:
                        OnAPressed?.Invoke(this, EventArgs.Empty);
                        break;
                    case ConsoleKey.D:
                        OnDPressed?.Invoke(this, EventArgs.Empty);
                        break;
                    default:
                        break;
                }

                Thread.Sleep(Program.PlayerSpeed);
            }
        }
    }
}
