﻿using System;
using System.Diagnostics;
using System.Text;
using System.Threading;

namespace PacManGame
{
    class Program
    {
        public static int[] Score = new int[] { 0, 0, 0 }; // Max Score = 245
        public static int[] PlayerCurrentPosition;

        public static int[] GhostCurrentPosition;
        public static Direction GhostDirection;
        public static Direction GhostBlockedDirection;
        public static bool IsFoodUnderGhost = false;
        public static bool FirstGhostMove = true;
        // public StringBuilder[] Screen;

        public static int screenHeight = 100;
        public static int screenWidth = 100;

        public static int GameSpeed = 75;
        public static int PlayerSpeed = 160;

        public static int[] PlayerStartPosition = new int[] { 38, 23 };
        public static int[] GhostStartPosition = new int[] { 38, 11 };
        public static int[] ScorePosition = new int[] { 73, 32 };
        public static int[] TonnelLeftPosition = new int[] { 2, 14 };
        public static int[] TonnelRightPosition = new int[] { 77, 14 };

        public static int[,] CoordinatesCellsForChoice = new int[,] { { 17, 1 }, { 62, 1 },
                                                                      { 2, 5 }, { 17, 5 }, { 26, 5 }, { 35 , 5 }, { 53 , 5 }, { 62, 5 }, { 77 , 5 },
                                                                      { 17 , 8 }, { 62 , 7 },
                                                                      { 17, 14 }, { 26, 14 }, { 53, 14 }, { 62 , 14 },
                                                                      { 26, 17 }, { 53 , 17 },
                                                                      { 17 , 20 }, { 26 , 20 }, { 53 , 20 }, { 62 , 20 },
                                                                      { 17 , 23 }, { 26 , 23 }, { 53 , 23 }, { 62 , 23 },
                                                                      { 8 , 26 }, { 71 , 26 },
                                                                      { 35 , 29 }, { 44 , 29 } };

        public static int[,] CoordinatesSpecialCellsForChoise = new int[,] { { 35 , 11 }, { 44 , 11 },
                                                                             { 35 , 23 }, { 44 , 23 } };

        public static char[] WallsSymbols = new char[] { '╔', '═', '║', '╗', '╝', '╚' };
        public static char[] PlayerSymbols = new char[] { '▐', '█', '▌' };
        public static char[] GhostSymbols = new char[] { ' ', '▒', ' ' };
        public static char[] FoodSymbols = new char[] { ' ', '■', ' ' };

        public static string[] GameMap = new string[] 
                                        { "╔════════════════════════════════════╗════╔════════════════════════════════════╗",
                                          "║ ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■ ║════║ ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■ ║",
                                          "║ ■ ╔══════════╗ ■ ╔═════════════╗ ■ ║════║ ■ ╔═════════════╗ ■ ╔══════════╗ ■ ║",
                                          "║ ■ ║══════════║ ■ ║═════════════║ ■ ║════║ ■ ║═════════════║ ■ ║══════════║ ■ ║",
                                          "║ ■ ╚══════════╝ ■ ╚═════════════╝ ■ ╚════╝ ■ ╚═════════════╝ ■ ╚══════════╝ ■ ║",
                                          "║ ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■ ║",
                                          "║ ■ ╔══════════╗ ■ ╔════╗ ■ ╔══════════════════════╗ ■ ╔════╗ ■ ╔══════════╗ ■ ║",
                                          "║ ■ ╚══════════╝ ■ ║════║ ■ ╚════════╗════╔════════╝ ■ ║════║ ■ ╚══════════╝ ■ ║",
                                          "║ ■  ■  ■  ■  ■  ■ ║════║ ■  ■  ■  ■ ║════║ ■  ■  ■  ■ ║════║ ■  ■  ■  ■  ■  ■ ║",
                                          "╚══════════════╗ ■ ║════╚════════╗   ║════║   ╔════════╝════║ ■ ╔══════════════╝",
                                          "═══════════════║ ■ ║════╔════════╝   ╚════╝   ╚════════╗════║ ■ ║═══════════════",
                                          "═══════════════║ ■ ║════║             ▒                ║════║ ■ ║═══════════════",
                                          "═══════════════║ ■ ║════║   ╔══════════════════════╗   ║════║ ■ ║═══════════════",
                                          "═══════════════╝ ■ ╚════╝   ║                      ║   ╚════╝ ■ ╚═══════════════",
                                          "                 ■          ║                      ║          ■                 ",
                                          "═══════════════╗ ■ ╔════╗   ║                      ║   ╔════╗ ■ ╔═══════════════",
                                          "═══════════════║ ■ ║════║   ╚══════════════════════╝   ║════║ ■ ║═══════════════",
                                          "═══════════════║ ■ ║════║                              ║════║ ■ ║═══════════════",
                                          "═══════════════║ ■ ║════║   ╔══════════════════════╗   ║════║ ■ ║═══════════════",
                                          "╔══════════════╝ ■ ╚════╝   ╚════════╗════╔════════╝   ╚════╝ ■ ╚══════════════╗",
                                          "║ ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■ ║════║ ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■ ║",
                                          "║ ■ ╔══════════╗ ■ ╔═════════════╗ ■ ║════║ ■ ╔═════════════╗ ■ ╔══════════╗ ■ ║",
                                          "║ ■ ╚═════╗════║ ■ ╚═════════════╝ ■ ╚════╝ ■ ╚═════════════╝ ■ ║════╔═════╝ ■ ║",
                                          "║ ■  ■  ■ ║════║ ■  ■  ■  ■  ■  ■  ■ ▐█▌ ■  ■  ■  ■  ■  ■  ■  ■ ║════║ ■  ■  ■ ║",
                                          "╚═════╗ ■ ║════║ ■ ╔════╗ ■ ╔══════════════════════╗ ■ ╔════╗ ■ ║════║ ■ ╔═════╝",
                                          "╔═════╝ ■ ╚════╝ ■ ║════║ ■ ╚════════╗════╔════════╝ ■ ║════║ ■ ╚════╝ ■ ╚═════╗",
                                          "║ ■  ■  ■  ■  ■  ■ ║════║ ■  ■  ■  ■ ║════║ ■  ■  ■  ■ ║════║ ■  ■  ■  ■  ■  ■ ║",
                                          "║ ■ ╔══════════════╝════╚════════╗ ■ ║════║ ■ ╔════════╝════╚══════════════╗ ■ ║",
                                          "║ ■ ╚════════════════════════════╝ ■ ╚════╝ ■ ╚════════════════════════════╝ ■ ║",
                                          "║ ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■  ■ ║",
                                          "╚══════════════════════════════════════════════════════════════════════════════╝",
                                          "                                                                                ",
                                          "                                                                  SCORE: 000    ",
                                          "                                                                                ",
                                          "                                                                                ",};

        public static string[] WinScreen = new string[]
        { "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                   YOU WIN!                                     ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
        };

        public static string[] LoseScreen = new string[]
        { "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                  YOU LOSE!                                     ",
          "                          YOU SHOULD AVOID THE GHOST                            ",
          "                     SERIOUSLY, IT'S EASY, WHY DO YOU LOSE?                     ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
          "                                                                                ",
        };


        public enum Direction 
        {
            Stop = 0,
            Up = 1,
            Down = 2,
            Left = 3,
            Right = 4,
        }

        public static bool CheckForMove(StringBuilder[] screenNow, Direction direction, int[] cords)
        {
            bool canMove = true;
            switch (direction)
            {
                case Direction.Up:
                    for (int i = 0; i < WallsSymbols.Length; i++)
                    {
                        if (screenNow[cords[1] - 1][cords[0]] == WallsSymbols[i])
                        {
                            canMove = false;
                        }
                    }
                    break;
                case Direction.Down:
                    for (int i = 0; i < WallsSymbols.Length; i++)
                    {
                        if (screenNow[cords[1] + 1][cords[0]] == WallsSymbols[i])
                        {
                            canMove = false;
                        }
                    }
                    break;
                case Direction.Left:
                    for (int i = 0; i < WallsSymbols.Length; i++)
                    {
                        if (screenNow[cords[1]][cords[0] - 2] == WallsSymbols[i])
                        {
                            canMove = false;
                        }
                    }
                    break;
                case Direction.Right:
                    for (int i = 0; i < WallsSymbols.Length; i++)
                    {
                        if (screenNow[cords[1]][cords[0] + 2] == WallsSymbols[i])
                        {
                            canMove = false;
                        }
                    }
                    break;
                case Direction.Stop:
                default:
                    break;
            }

            return canMove;
        }

        public static StringBuilder[] StringToStringBuilderArray(string[] str)
        {
            StringBuilder[] sb = new StringBuilder[str.Length];
            for (int i = 0; i < str.Length; i++)
            {
                sb[i] = new StringBuilder(str[i]);
            }
            return sb;
        }

        static void ClearBuffer()
        {
            while (Console.KeyAvailable)
            {
                Console.ReadKey(true);
            }
        }

        public static void DrawScreen(StringBuilder[] sb)
        {
            var whiteSpace = new StringBuilder();
            whiteSpace.Append(' ', 14);
            Console.SetCursorPosition(0, 0);
            for (int i = 0; i < sb.Length; i++)
            {
                Console.SetCursorPosition(0, i);
                Console.Write(sb[i]);
                Console.Write(whiteSpace);
            }
            Console.CursorVisible = false;
        }

        public static StringBuilder[] FirstInit(StringBuilder[] sb)
        {
            StringBuilder[] finalSb = new StringBuilder[sb.Length + 5];
            int i;
            for (i = 0; i < sb.Length; i++)
            {
                finalSb[i] = sb[i];
            }
            return finalSb;
        }

        public static bool CheckForFood(StringBuilder[] screen, int[] cords)
        {
            if (screen[cords[1]][cords[0]] == FoodSymbols[1])
            {
                return true;
            }

            return false;
        }

        public static StringBuilder[] IncrementScore(StringBuilder[] sb)
        {
            Score[2]++;
            if (Score[2] > 9)
            {
                Score[1]++;
                Score[2] = 0;
            }
            if (Score[1] > 9)
            {
                Score[0]++;
                Score[1] = 0;
            }
            sb[ScorePosition[1]][ScorePosition[0]] = Convert.ToChar(Convert.ToString(Score[0]));
            sb[ScorePosition[1]][ScorePosition[0] + 1] = Convert.ToChar(Convert.ToString(Score[1]));
            sb[ScorePosition[1]][ScorePosition[0] + 2] = Convert.ToChar(Convert.ToString(Score[2]));
            return sb;
        }

        public static StringBuilder[] PlayerMoveRender(StringBuilder[] screen, int[] cords, Direction direction)
        {
            int[] newCords = new int[2];
            switch (direction)
            {
                case Direction.Up:
                    if (CheckForMove(screen, direction, cords))
                    {
                        newCords[0] = cords[0];
                        newCords[1] = cords[1] - 1;
                        if (CheckForFood(screen, newCords))
                        {
                            screen = IncrementScore(screen);
                        }
                        screen[cords[1]][cords[0] - 1] = ' ';
                        screen[cords[1]][cords[0]] = ' ';
                        screen[cords[1]][cords[0] + 1] = ' ';

                        screen[newCords[1]][newCords[0] - 1] = PlayerSymbols[0];
                        screen[newCords[1]][newCords[0]] = PlayerSymbols[1];
                        screen[newCords[1]][newCords[0] + 1] = PlayerSymbols[2];

                        PlayerCurrentPosition[1]--;
                    }
                    break;

                case Direction.Down:
                    if (CheckForMove(screen, direction, cords))
                    {
                        newCords[0] = cords[0];
                        newCords[1] = cords[1] + 1;
                        if (CheckForFood(screen, newCords))
                        {
                            screen = IncrementScore(screen);
                        }
                        screen[cords[1]][cords[0] - 1] = ' ';
                        screen[cords[1]][cords[0]] = ' ';
                        screen[cords[1]][cords[0] + 1] = ' ';

                        screen[newCords[1]][newCords[0] - 1] = PlayerSymbols[0];
                        screen[newCords[1]][newCords[0]] = PlayerSymbols[1];
                        screen[newCords[1]][newCords[0] + 1] = PlayerSymbols[2];

                        PlayerCurrentPosition[1]++;
                    }

                    break;

                case Direction.Left:
                    if (CheckForMove(screen, direction, cords))
                    {
                        newCords[0] = cords[0] - 3;
                        newCords[1] = cords[1];
                        bool wasTeleported = false;

                        if (newCords[0] < TonnelLeftPosition[0])
                        {
                            newCords[0] = TonnelRightPosition[0];
                            PlayerCurrentPosition[0] = TonnelRightPosition[0];
                            screen[TonnelLeftPosition[1]][TonnelLeftPosition[0] - 1] = ' ';
                            screen[TonnelLeftPosition[1]][TonnelLeftPosition[0]] = ' ';
                            screen[TonnelLeftPosition[1]][TonnelLeftPosition[0] + 1] = ' ';
                            wasTeleported = true;
                        }

                        if (CheckForFood(screen, newCords))
                        {
                            screen = IncrementScore(screen);
                        }
                        screen[cords[1]][cords[0] - 1] = ' ';
                        screen[cords[1]][cords[0]] = ' ';
                        screen[cords[1]][cords[0] + 1] = ' ';

                        screen[newCords[1]][newCords[0] - 1] = PlayerSymbols[0];
                        screen[newCords[1]][newCords[0]] = PlayerSymbols[1];
                        screen[newCords[1]][newCords[0] + 1] = PlayerSymbols[2];

                        if (!wasTeleported)
                            PlayerCurrentPosition[0] -= 3;
                    }
                    break;

                case Direction.Right:
                    if (CheckForMove(screen, direction, cords))
                    {
                        bool wasTeleported = false;

                        newCords[0] = cords[0] + 3;
                        newCords[1] = cords[1];

                        if (newCords[0] > TonnelRightPosition[0])
                        {
                            newCords[0] = TonnelLeftPosition[0];
                            PlayerCurrentPosition[0] = TonnelLeftPosition[0];
                            screen[TonnelRightPosition[1]][TonnelRightPosition[0] - 1] = ' ';
                            screen[TonnelRightPosition[1]][TonnelRightPosition[0]] = ' ';
                            screen[TonnelRightPosition[1]][TonnelRightPosition[0] + 1] = ' ';
                            wasTeleported = true;
                        }

                        if (CheckForFood(screen, newCords))
                        {
                            screen = IncrementScore(screen);
                        }
                        screen[cords[1]][cords[0] - 1] = ' ';
                        screen[cords[1]][cords[0]] = ' ';
                        screen[cords[1]][cords[0] + 1] = ' ';

                        screen[newCords[1]][newCords[0] - 1] = PlayerSymbols[0];
                        screen[newCords[1]][newCords[0]] = PlayerSymbols[1];
                        screen[newCords[1]][newCords[0] + 1] = PlayerSymbols[2];

                        if (!wasTeleported)
                            PlayerCurrentPosition[0] += 3;
                    }
                    break;

                default:
                    break;
            }
            return screen;
        }

        public static Direction NormalChooseDirection(StringBuilder[] screen, int[] cords)
        {
            int[] newCords = new int[2];
            var random = new Random();
            bool correctDirection = false;
            Direction newDirection = Direction.Stop;
            while (!correctDirection)
            {
                newDirection = (Direction)random.Next(1, 5);
                if (newDirection != GhostBlockedDirection)
                {
                    correctDirection = CheckForMove(screen, newDirection, cords);
                }
            }

            return newDirection;
        }

        public static StringBuilder[] GhostMoveRender(StringBuilder[] screen, int[] cords, Direction direction)
        {
            int[] newCords = new int[2];
            bool isChoiceCell = false;
            bool correctDirection = false;
            bool isFoodUnderNextCoordinates = false;
            bool wasTeleported;
            Random random = new Random();

            for (int i = 0; i < 29; i++)
            {
                if (cords[0] == CoordinatesCellsForChoice[i, 0] & cords[1] == CoordinatesCellsForChoice[i, 1])
                {
                    direction = NormalChooseDirection(screen, cords);
                    isChoiceCell = true;
                    break;
                }
            }

            if (!isChoiceCell & !FirstGhostMove)
            {
                if (!CheckForMove(screen, direction, cords))
                {
                    while(!correctDirection)
                    {
                        direction = (Direction)(random.Next(1, 5));
                        if (direction != GhostBlockedDirection)
                        {
                            correctDirection = CheckForMove(screen, direction, cords);
                        }
                    }
                }
            }

            if (FirstGhostMove)
            {
                direction = (Direction)(random.Next(3, 5));
                GhostDirection = direction;
                FirstGhostMove = false;
            }

            switch (direction)
            {
                case Direction.Up:
                    newCords[0] = cords[0];
                    newCords[1] = cords[1] - 1;

                    if (screen[newCords[1]][newCords[0]] == FoodSymbols[1])
                    {
                        isFoodUnderNextCoordinates = true;
                    }

                    screen[newCords[1]][newCords[0] - 1] = GhostSymbols[0];
                    screen[newCords[1]][newCords[0]] = GhostSymbols[1];
                    screen[newCords[1]][newCords[0] + 1] = GhostSymbols[2];

                    if (IsFoodUnderGhost)
                    {
                        screen[cords[1]][cords[0] - 1] = FoodSymbols[0];
                        screen[cords[1]][cords[0]] = FoodSymbols[1];
                        screen[cords[1]][cords[0] + 1] = FoodSymbols[2];
                    }
                    else
                    {
                        screen[cords[1]][cords[0] - 1] = ' ';
                        screen[cords[1]][cords[0]] = ' ';
                        screen[cords[1]][cords[0] + 1] = ' ';
                    }
                    
                    GhostCurrentPosition[1]--;
                    GhostDirection = Direction.Up;
                    GhostBlockedDirection = Direction.Down;
                    IsFoodUnderGhost = isFoodUnderNextCoordinates;
                    break;

                case Direction.Down:
                    newCords[0] = cords[0];
                    newCords[1] = cords[1] + 1;

                    if (screen[newCords[1]][newCords[0]] == FoodSymbols[1])
                    {
                        isFoodUnderNextCoordinates = true;
                    }

                    screen[newCords[1]][newCords[0] - 1] = GhostSymbols[0];
                    screen[newCords[1]][newCords[0]] = GhostSymbols[1];
                    screen[newCords[1]][newCords[0] + 1] = GhostSymbols[2];

                    if (IsFoodUnderGhost)
                    {
                        screen[cords[1]][cords[0] - 1] = FoodSymbols[0];
                        screen[cords[1]][cords[0]] = FoodSymbols[1];
                        screen[cords[1]][cords[0] + 1] = FoodSymbols[2];
                    }
                    else
                    {
                        screen[cords[1]][cords[0] - 1] = ' ';
                        screen[cords[1]][cords[0]] = ' ';
                        screen[cords[1]][cords[0] + 1] = ' ';
                    }

                    GhostCurrentPosition[1]++;
                    GhostDirection = Direction.Down;
                    GhostBlockedDirection = Direction.Up;
                    IsFoodUnderGhost = isFoodUnderNextCoordinates;
                    break;

                case Direction.Left:
                    wasTeleported = false;
                    newCords[0] = cords[0] - 3;
                    newCords[1] = cords[1];

                    if (newCords[0] < TonnelLeftPosition[0])
                    {
                        newCords[0] = TonnelRightPosition[0];
                        GhostCurrentPosition[0] = TonnelRightPosition[0];
                        screen[TonnelLeftPosition[1]][TonnelLeftPosition[0] - 1] = ' ';
                        screen[TonnelLeftPosition[1]][TonnelLeftPosition[0]] = ' ';
                        screen[TonnelLeftPosition[1]][TonnelLeftPosition[0] + 1] = ' ';
                        wasTeleported = true;
                    }

                    if (screen[newCords[1]][newCords[0]] == FoodSymbols[1])
                    {
                        isFoodUnderNextCoordinates = true;
                    }

                    screen[newCords[1]][newCords[0] - 1] = GhostSymbols[0];
                    screen[newCords[1]][newCords[0]] = GhostSymbols[1];
                    screen[newCords[1]][newCords[0] + 1] = GhostSymbols[2];

                    if (IsFoodUnderGhost)
                    {
                        screen[cords[1]][cords[0] - 1] = FoodSymbols[0];
                        screen[cords[1]][cords[0]] = FoodSymbols[1];
                        screen[cords[1]][cords[0] + 1] = FoodSymbols[2];
                    }
                    else
                    {
                        screen[cords[1]][cords[0] - 1] = ' ';
                        screen[cords[1]][cords[0]] = ' ';
                        screen[cords[1]][cords[0] + 1] = ' ';
                    }

                    if(!wasTeleported)
                        GhostCurrentPosition[0] -= 3;

                    GhostDirection = Direction.Left;
                    GhostBlockedDirection = Direction.Right;
                    IsFoodUnderGhost = isFoodUnderNextCoordinates;
                    break;

                case Direction.Right:
                    wasTeleported = false;
                    newCords[0] = cords[0] + 3;
                    newCords[1] = cords[1];

                    if (newCords[0] > TonnelRightPosition[0])
                    {
                        newCords[0] = TonnelLeftPosition[0];
                        GhostCurrentPosition[0] = TonnelLeftPosition[0];
                        screen[TonnelRightPosition[1]][TonnelRightPosition[0] - 1] = ' ';
                        screen[TonnelRightPosition[1]][TonnelRightPosition[0]] = ' ';
                        screen[TonnelRightPosition[1]][TonnelRightPosition[0] + 1] = ' ';
                        wasTeleported = true;
                    }

                    if (screen[newCords[1]][newCords[0]] == FoodSymbols[1])
                    {
                        isFoodUnderNextCoordinates = true;
                    }

                    screen[newCords[1]][newCords[0] - 1] = GhostSymbols[0];
                    screen[newCords[1]][newCords[0]] = GhostSymbols[1];
                    screen[newCords[1]][newCords[0] + 1] = GhostSymbols[2];

                    if (IsFoodUnderGhost)
                    {
                        screen[cords[1]][cords[0] - 1] = FoodSymbols[0];
                        screen[cords[1]][cords[0]] = FoodSymbols[1];
                        screen[cords[1]][cords[0] + 1] = FoodSymbols[2];
                    }
                    else
                    {
                        screen[cords[1]][cords[0] - 1] = ' ';
                        screen[cords[1]][cords[0]] = ' ';
                        screen[cords[1]][cords[0] + 1] = ' ';
                    }

                    if(!wasTeleported)
                        GhostCurrentPosition[0] += 3;

                    GhostDirection = Direction.Right;
                    GhostBlockedDirection = Direction.Left;
                    IsFoodUnderGhost = isFoodUnderNextCoordinates;
                    break;

                default:
                    break;
            }

            return screen;
        }

        public static StringBuilder[] GhostMoveLeft(StringBuilder[] scene, int[] position)
        {
            int[] newCoordinates = new int[2];
            newCoordinates[0] = position[0] - 3;
            newCoordinates[1] = position[1];

            scene[position[1]][position[0] - 1] = ' ';
            scene[position[1]][position[0]] = ' ';
            scene[position[1]][position[0] + 1] = ' ';

            scene[newCoordinates[1]][newCoordinates[0] - 1] = GhostSymbols[0];
            scene[newCoordinates[1]][newCoordinates[0]] = GhostSymbols[1];
            scene[newCoordinates[1]][newCoordinates[0] + 1] = GhostSymbols[2];

            GhostCurrentPosition[0] -= 3;

            return scene;
        }

        static void Main(string[] args)
        {   
            Console.SetWindowPosition(0, 0);
            Console.WindowWidth = Console.LargestWindowWidth;
            Console.WindowHeight = Console.LargestWindowHeight;
            

            bool isRunning = true;
            bool isWinning = false;

            PlayerCurrentPosition = PlayerStartPosition;
            GhostCurrentPosition = GhostStartPosition;
            PlayerController playerController = new PlayerController();

            StringBuilder[] Screen = StringToStringBuilderArray(GameMap);

            DrawScreen(Screen);

            playerController.OnWPressed += (obj, args) => PlayerMoveRender(Screen, PlayerCurrentPosition, Direction.Up);
            playerController.OnSPressed += (obj, args) => PlayerMoveRender(Screen, PlayerCurrentPosition, Direction.Down);
            playerController.OnAPressed += (obj, args) => PlayerMoveRender(Screen, PlayerCurrentPosition, Direction.Left);
            playerController.OnDPressed += (obj, args) => PlayerMoveRender(Screen, PlayerCurrentPosition, Direction.Right);

            Thread controllerThread = new Thread(playerController.StartListening);

            controllerThread.Start();

            while (isRunning)
            {
                Screen = GhostMoveRender(Screen, GhostCurrentPosition, GhostDirection);
                DrawScreen(Screen);
                ClearBuffer();
                if (Score[0] * 100 + Score[1] * 10 + Score[2] >= 245)
                {
                    isRunning = false;
                    isWinning = true;
                }
                if (PlayerCurrentPosition[0] == GhostCurrentPosition[0] & PlayerCurrentPosition[1] == GhostCurrentPosition[1])
                {
                    isRunning = false;
                }
                Thread.Sleep(GameSpeed);
            }

            Console.Clear();

            if (isWinning)
                DrawScreen(StringToStringBuilderArray(WinScreen));
            else
                DrawScreen(StringToStringBuilderArray(LoseScreen));
        }
    }
}
